	
	DEF fnMinX(r) = r
	DEF fnMaxX(r) = width -(r)-1
	DEF fnMinY(r) = r
	DEF fnMaxY(r) = height-(r)-1

	DEF fnInRange(x,y,r) = x > fnMinX(r) AND x < fnMaxX(r) AND y > fnMinY(r) AND y < fnMaxY(r)

	DEF fnRndInt(minv,maxv) = RND(1)*(maxv-minv)+minv

	updIntv = 10	// Screen update interval in ms
	W=1
	INPUT "Window Width,Height:",width,height

	WINDOW @W;width,height

	dx = fnRndInt(11,width-11)
	dy = fnRndInt(11,height-11)
	REPEAT
		ix=fnRndInt(-30,30)
		iy=fnRndInt(-20,20)
	UNTIL ix<>0 AND iy<>0

	ds = 1
	dr = 10

	GOSUB RandomColor
	dt = tim(11) + updIntv
	WHILE 1
		nx = dx+ix
		ny = dy+iy
		IF fnInRange(nx,ny,dr) THEN
			GOSUB DrawCircle
			IF dr + ds < 0 THEN
				ds = -ds
			ENDIF
			dr = dr + ds
			dx = nx
			dy = ny
		ELSE
			REPEAT
				ix=fnRndInt(-30,30)
				iy=fnRndInt(-20,20)
			UNTIL ix<>0 AND iy<>0
			ds = -ds
			dr = dr + ds
			GOSUB RandomColor
		ENDIF

		IF tim(11) >= dt THEN
			UPDATE @W
			dt = tim(11) + updIntv
		ENDIF
	NEXT
	STOP

	! Draw Circle
	! Inputs:	dX,dY	- location
	!			dR		- Radius
	!			W		- Window
	!
DrawCircle:
	FOR ii=0 TO PI()*2 STEP PI()/20
		xx=COS(ii)*dR+dX
		yy=SIN(ii)*dR+dY
		IF ii=0 THEN
			MOVETO @W;xx,yy
		ELSE
			LINETO @W;xx,yy
		ENDIF
	NEXT ii
	RETURN

	! Randomize Color
	! Inputs:	W - Window
	!
RandomColor:
	r=fnRndInt(0,255)
	g=fnRndInt(0,255)
	b=fnRndInt(0,255)
	COLOR @W;r,g,b
	RETURN

